#include <TFT.h>
#include <SPI.h>
#define TFT_CS        10
#define TFT_RST        9 
#define TFT_DC         8
TFT ecran = TFT(TFT_CS,TFT_DC,TFT_RST);

//Definition des pins a utiliser
const int PIN_POTENTIO = A0;
const int PIN_BOUTTON_SUP = 2;
const int PIN_BOUTTON_INF = 3;
const int PIN_BOUTTON_VALIDER = 7;
//Temps en secondes avant la veille prolongée
const byte TEMPS_VEILLE = 20;
//Temps en secondes avant le retour au menu principale forcée
const byte TEMPS_RETOUR_MENU_PRINCIPAL = 15;
//Variable comprise entre 0 et 1024 --> Regler le son au demmarager de l'aplication
const int INITIAL_SON = 512; 
//Variable permetant de definir le nombre d'aplication a controler
const int NOMBRE_DE_GESTION = 14;
//Variable permettant de compter le nombre de favoris/Application enregistrer (Si ces valeurs sont changées --> probleme menu)
byte NOMBRE_FAVORIS = 4;
byte NOMBRE_APP = 10;

//Ne pas changer ces valeurs ci dessous

byte Menu_favoris = 0;
byte PositionFavoris = 0;
bool AfficheFavBool = false;
bool AfficheAppBool = false;
bool AfficheJeuxBool = false;
bool AfficheMenuApBool = false;
bool VeilleProlongeBool = false;
bool AffichePrincipalBool = true;
byte Menu_Application = 0;
byte Menu_Jeux = 0;
int PositionAPP = 0;
byte DernierMenu = 0; //0 pour principale | 1 pour fav |2 pour app | 3pour jeux.
long DERNIER_UTILISATION = 0;
byte Menu_Principale = 0;
//Tableau permetant de stoquer les valeurs de chaque application
int VALEUR_GESTION[NOMBRE_DE_GESTION];
//Variable contenant le numero de chaque application
int NUMERO_APLICATION_SON = 0;

// ----------------------------------------------------------------- SETUP ------------------------------------------------

void setup() {
  attachInterrupt(digitalPinToInterrupt(PIN_BOUTTON_SUP),Boutton_Clique_Plus, RISING);
  attachInterrupt(digitalPinToInterrupt(PIN_BOUTTON_INF),Boutton_Clique_Moins, RISING);
  Serial.begin(9600);

  //initialisation touts les son a 50%
  for(int i=0;i<NOMBRE_DE_GESTION;i++){
    VALEUR_GESTION[i] = INITIAL_SON;
  }

  //Initialisation ecran
  ecran.begin();
  ecran.background(105, 105, 105);
  AfficheMenuPrincipale(Menu_Principale);
}

//-------------------------------------------------- LOOP ---------------------------------------------------

void loop() {
    //Condition pour la veille prolongé
    if(VerificationPlusActif(TEMPS_VEILLE) == false){
      AfficheAppBool = false;
      AffichePrincipalBool = false;
      AfficheFavBool = false;
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      VeilleProlongeBool = true;
      VeilleProlonge();
  }
  //Condition pour le retour au menu principal
  else if(VerificationPlusActif(TEMPS_RETOUR_MENU_PRINCIPAL) == false){
    if(AffichePrincipalBool == false){
      AfficheAppBool = false;
      AffichePrincipalBool = true;
      AfficheFavBool = false;
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      VeilleProlongeBool = false;
      Menu_Principale = 0;
      AfficheMenuPrincipale(Menu_Principale);
    } 
  }


  if(AfficheAppBool == true){
    TracerGraphe();
  }
  //Quand le bouton valider est appuyer
  if(digitalRead(PIN_BOUTTON_VALIDER) == HIGH){
    Bouton_Valider();
  }
  ENVOIE_DATA();
  delay(100);
}


//------------------------------------------------- FONCTION DE CHOIX ------------------------------------------------- 



void ChoixJeuxFinal(){
  switch(Menu_Jeux){
    case(0):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Jeux", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AffichePrincipalBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 14;
    break;
    
    case(1):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Microphone", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 13;
    break;
  }//------------------------------------------
}



void ChoixApplicationFinal(){
   switch(PositionAPP){
    case(0):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Discord", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AffichePrincipalBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 1;
    break;
    
    case(1):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Chrome", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 2;
    break;
    
    case(2):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Spotify", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 3;
    break;

    case(3):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("OBS", 60, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 5;
    break;

    case(4):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("VLC", 60, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 6;
    break;
    case(5):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Steam", 40, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 7;
    break;
    case(6):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Deezer", 30, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 8;
    break;
    case(7):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Netflix", 30, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 9;
    break;
    case(8):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Prime Video", 20, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 10;
    break;
    case(9):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Messenger", 30, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 11;
    break;
    case(10):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Whatssap", 30, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 12;
    break;         
   }
}


void ChoixApplicationFav(){
   switch(PositionFavoris){
    case(0):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Son systeme", 15, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 0;
    break;
    
    case(1):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Discord", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 1;
    break;
    
    case(2):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Chrome", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 2;
    break;

    case(3):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Spotify", 45, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 3;
    break;

    case(4):
      ecran.background(ST7735_BLACK);
      ecran.stroke(255, 255, 255); //Couleur de l'écriture
      ecran.setTextSize(2);
      ecran.text("Teamspeak", 30, 6);
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavBool = false;
      AfficheAppBool = true;
      NUMERO_APLICATION_SON = 4;
    break;
   }
}

void ChoixMenuPrincipale(){
  switch(Menu_Principale){
    case 0:
      AfficheAppBool = false;
      AfficheFavBool = true;
      AffichePrincipalBool = false;
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheFavoris();
    break;
    case 1:
      AfficheJeuxBool = false;
      AfficheMenuApBool = true;
      AfficheAppBool = false;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
      AfficheApplications();
    break;
    case 2:
      AfficheJeuxBool = true;
      AfficheMenuApBool = false;
      AfficheAppBool = false;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
      AfficheJeux();
    break;
  }
}


//------------------------------------------------------------ FONCTION AFFICHAGE ------------------------------------------------------------



void TracerGraphe(){
  byte valeur = map(analogRead(PIN_POTENTIO),0,1023,0,100);
  ecran.fillRect((30+valeur),50,100,30,ST7735_BLACK);
  ecran.fillRect(30,50,valeur,30,ST7735_WHITE);
  ecran.drawRect(30,50,100,30,ST7735_WHITE);
}


//Fonction a finir
void AfficheApplications(){
  ecran.setTextSize(1);
  ecran.background(105, 105, 105);
  ecran.stroke(255, 255, 255); //Couleur de l'écriture
  ecran.text("Applications", 45, 6);
  switch (Menu_Application){
    case 0:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 1:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 2:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_BLACK);
    break; 
  }
  ecran.fillRoundRect(9, 19, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 54, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 89, 140, 29, 9, ST7735_WHITE);
  ecran.stroke(69, 69, 69); //Couleur de l'écriture
  if(PositionAPP<=2){
    ecran.text("Discord", 28, 31);
    ecran.text("Chrome", 28, 66);
    ecran.text("Spotify", 28, 101);
  }
  else if(PositionAPP == 3){
    ecran.text("Chrome", 28, 31);
    ecran.text("Spotify", 28, 66);
    ecran.text("Obs", 28, 101);
  }
  else if(PositionAPP == 4){
    ecran.text("Spotify", 28, 31);
    ecran.text("Obs", 28, 66);
    ecran.text("VLC", 28, 101);    
  }
  else if(PositionAPP == 5){
    ecran.text("Obs", 28, 31);
    ecran.text("VLC", 28, 66);
    ecran.text("Steam", 28, 101);    
  }
  else if(PositionAPP == 6){
    ecran.text("VLC", 28, 31);
    ecran.text("Steam", 28, 66);
    ecran.text("Deezer", 28, 101);    
  }
  else if(PositionAPP == 7){
    ecran.text("Steam", 28, 31);
    ecran.text("Deezer", 28, 66);
    ecran.text("Netflix", 28, 101);    
  } 
  else if(PositionAPP == 8){
    ecran.text("Deezer", 28, 31);
    ecran.text("Netflix", 28, 66);
    ecran.text("Prime Video", 28, 101);    
  }
  else if(PositionAPP == 9){
    ecran.text("Netflix", 28, 31);
    ecran.text("Prime Video", 28, 66);
    ecran.text("Messenger", 28, 101);    
  }  
  else if(PositionAPP == 10){
    ecran.text("Prime Video", 28, 31);
    ecran.text("Messenger", 28, 66);
    ecran.text("Whatsapp", 28, 101);    
  } 
}
void AfficheJeux(){
  ecran.setTextSize(1);
  ecran.background(105, 105, 105);
  ecran.stroke(255, 255, 255); //Couleur de l'écriture
  ecran.text("Jeux", 70, 6);
  switch (Menu_Jeux){
    case 0:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
    break;

    case 1:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_BLACK);
    break;
  }
  ecran.fillRoundRect(9, 19, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 54, 140, 29, 9, ST7735_WHITE);
  ecran.stroke(69, 69, 69); //Couleur de l'écriture
  ecran.text("Jeux", 28, 31);
  ecran.text("Microphone", 28, 66);   
}

void AfficheFavoris(){
  ecran.setTextSize(1);
  ecran.background(105, 105, 105);
  ecran.stroke(255, 255, 255); //Couleur de l'écriture
  ecran.text("Favoris", 60, 6);
  switch (Menu_favoris){
    case 0:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 1:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 2:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_BLACK);
    break;
    
  }
  ecran.fillRoundRect(9, 19, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 54, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 89, 140, 29, 9, ST7735_WHITE);
  ecran.stroke(69, 69, 69); //Couleur de l'écriture
  if(PositionFavoris<=2){
    ecran.text("Son systeme", 28, 31);
    ecran.text("Discord", 28, 66);
    ecran.text("Chrome", 28, 101);
  }
  else if(PositionFavoris == 3){
    ecran.text("Discord", 28, 31);
    ecran.text("Chrome", 28, 66);
    ecran.text("Spotify", 28, 101);
  }
  else if(PositionFavoris == 4){
    ecran.text("Chrome", 28, 31);
    ecran.text("Spotify", 28, 66);
    ecran.text("Teamspeak", 28, 101);    
  }
}


void VeilleProlonge(){
  ecran.background(0, 0, 0);
}



//Fonction qui prend en entrée un entier compris entre 0 et 2 et qui affiche le menu avec la case selectioner.
void AfficheMenuPrincipale(byte Selection){
  ecran.background(105, 105, 105);
  ecran.setTextSize(1);
  switch (Selection){
    case 0:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 1:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_BLACK);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_WHITE);
    break;

    case 2:
      ecran.drawRoundRect(10, 20, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 55, 140, 30, 10, ST7735_WHITE);
      ecran.drawRoundRect(10, 90, 140, 30, 10, ST7735_BLACK);
    break;
    
  }
  ecran.fillRoundRect(9, 19, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 54, 140, 29, 9, ST7735_WHITE);
  ecran.fillRoundRect(9, 89, 140, 29, 9, ST7735_WHITE);
  ecran.setTextSize(1);
  ecran.stroke(255, 255, 255); //Couleur de l'écriture
  ecran.text("Melangeur de volume", 20, 6);

  ecran.stroke(69, 69, 69); //Couleur de l'écriture
  ecran.text("Favoris", 28, 31);
  ecran.text("Applications", 28, 66);
  ecran.text("Jeux", 28, 101);
}




//----------------------------FONCTION UTILE APRES PRESSION SUR UN BOUTON-----------------------------------



void Bouton_Valider(){
  if(VeilleProlongeBool == true){
    VeilleProlongeBool = false;
    AfficheJeuxBool = false;
    AfficheMenuApBool = false;
    AfficheAppBool = false;
    AfficheFavBool = false;
    AffichePrincipalBool = true;
  }
  DERNIER_UTILISATION = millis();
  if(AfficheAppBool == true){
    CAPTURE_DATA(NUMERO_APLICATION_SON);
  }
  if(AffichePrincipalBool == true){
    DernierMenu = 0;
    ChoixMenuPrincipale();
    
  }
  if(AfficheFavBool == true){
    DernierMenu = 1;
    ChoixApplicationFav();

  }
  if(AfficheMenuApBool == true){
    DernierMenu = 2;
    ChoixApplicationFinal();

  }
  if(AfficheJeuxBool == true){    
    DernierMenu = 3;
    ChoixJeuxFinal();
  }
}






void Boutton_Clique_Moins (){
  if(VeilleProlongeBool == true){
    VeilleProlongeBool = false;
    AfficheJeuxBool = false;
    AfficheMenuApBool = false;
    AfficheAppBool = false;
    AfficheFavBool = false;
    AffichePrincipalBool = true;
  }  
  DERNIER_UTILISATION = millis();
  if(AfficheAppBool == true){
    if(DernierMenu == 1){
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheAppBool = false;
      AfficheFavBool = true;
      AffichePrincipalBool = false;
    }
    if(DernierMenu == 2){
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheAppBool = true;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
    }
    if(DernierMenu == 3){
      AfficheJeuxBool = true;
      AfficheMenuApBool = false;
      AfficheAppBool = false;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
    }
     
  }   
  if(NUMERO_APLICATION_SON == 0){
    NUMERO_APLICATION_SON = (NOMBRE_DE_GESTION -1);
  }
  else{
    NUMERO_APLICATION_SON -= 1;
  }
  
  if((Menu_Principale == 0)&&(AffichePrincipalBool == true)){
    Menu_Principale = 2;
  }
  else if(AffichePrincipalBool == true){
    Menu_Principale -=1;
  }
  
  if((AfficheFavBool == true)&&(Menu_favoris == 0)){
    Menu_favoris = 0;
  }
  else if(AfficheFavBool == true){
    Menu_favoris -=1;
  }
  if((Menu_Jeux == 0)&&(AfficheJeuxBool == true)){
    Menu_Jeux = 0;
  }
  else if(AfficheJeuxBool == true){
    Menu_Jeux -=1;
  }
  
  if((AfficheMenuApBool == true)&&(Menu_Application == 0)){      
    Menu_Application = 0;
  } 
  else if(AfficheMenuApBool == true){       
    Menu_Application -=1;
  }

  if((PositionFavoris == 0)&&(AfficheFavBool == true)){
    PositionFavoris = 0;
  }
  else if((AfficheFavBool == true)&&(Menu_favoris == 0)){
    PositionFavoris -=1;
  }
  if((PositionAPP == 0)&&(AfficheMenuApBool == true)){
    PositionAPP = 0;  
  }                                                           
  else if((AfficheMenuApBool == true)&&(Menu_Application == 0)){       
    PositionAPP -=1;
  }
  
  if(AffichePrincipalBool == true){
    AfficheMenuPrincipale(Menu_Principale);
  }
  if(AfficheFavBool == true){
    AfficheFavoris();
  }
  if(AfficheMenuApBool == true){
    AfficheApplications();
  }
  if(AfficheJeuxBool == true){   
    AfficheJeux();
  }
  

  
}

void Boutton_Clique_Plus (){
    if(VeilleProlongeBool == true){
    VeilleProlongeBool = false;
    AfficheJeuxBool = false;
    AfficheMenuApBool = false;
    AfficheAppBool = false;
    AfficheFavBool = false;
    AffichePrincipalBool = true;
  }
  DERNIER_UTILISATION = millis();
  if(AfficheAppBool == true){
    if(DernierMenu == 1){
      AfficheJeuxBool = false;
      AfficheMenuApBool = false;
      AfficheAppBool = false;
      AfficheFavBool = true;
      AffichePrincipalBool = false;
    }
    if(DernierMenu == 2){
      AfficheJeuxBool = false;
      AfficheMenuApBool = true;
      AfficheAppBool = false;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
    }
    if(DernierMenu == 3){
      AfficheJeuxBool = true;
      AfficheMenuApBool = false;
      AfficheAppBool = false;
      AfficheFavBool = false;
      AffichePrincipalBool = false;
    }
     
  }   
  if(NUMERO_APLICATION_SON == (NOMBRE_DE_GESTION - 1)){
    NUMERO_APLICATION_SON = 0;
  }
  else{
    NUMERO_APLICATION_SON += 1;
  }

  
  if((Menu_Principale == 2)&&(AffichePrincipalBool == true)){
    Menu_Principale = 0;
  } 
  else if(AffichePrincipalBool == true){
    Menu_Principale +=1;
  }


  if((AfficheFavBool == true)&&(Menu_favoris == 2)){
    Menu_favoris = 2;
  }
  else if(AfficheFavBool == true){
    Menu_favoris += 1;
  }

   if((AfficheMenuApBool == true)&&(Menu_Application == 2)){
    Menu_Application = 2; 
  }                                                              
  else if(AfficheMenuApBool == true){
    Menu_Application += 1;
  }
  if((Menu_Jeux == 1)&&(AfficheJeuxBool == true)){
    Menu_Jeux = 1;
  }
  else if(AfficheJeuxBool == true){
    Menu_Jeux +=1;
  }

  if((PositionFavoris == (NOMBRE_FAVORIS))&&(AfficheFavBool == true)){
    PositionFavoris = (NOMBRE_FAVORIS);
  }
  else if((AfficheFavBool == true)&&(Menu_favoris == 2)){    
    PositionFavoris +=1;
  }

  if((PositionAPP == (NOMBRE_APP))&&(AfficheMenuApBool == true)){
    PositionAPP = (NOMBRE_APP);                                               
  }
  else if((AfficheMenuApBool == true)&&(Menu_Application == 2)){
    PositionAPP +=1;
  }

  if(AffichePrincipalBool == true){
    AfficheMenuPrincipale(Menu_Principale);
  }
  if(AfficheFavBool == true){
    AfficheFavoris();
  }
  if(AfficheMenuApBool == true){
    AfficheApplications();
  }
  if(AfficheJeuxBool == true){     
    AfficheJeux();
  } 
}



//------------------------------------ FONCTION PROG NE PAS TOUCHER ------------------------------------




//Fonction qui permet d'enregistrer un volume sonore d'une unique aplication identifié par la variable 'NUMERO_GESTION_SON'
//La variable 'NUMERO_GESTION_SON' doit obligatoirement etre inférieur ou égale a la constante 'NOMBRE_DE_GESTION'
void CAPTURE_DATA(int NUMERO_GESTION_SON){
  VALEUR_GESTION[NUMERO_GESTION_SON] = analogRead(PIN_POTENTIO); 
}


//Fontion permettant l'envoie de données selon la syntax choisi par les devellopers 'deej'
void ENVOIE_DATA() {
  String builtString = String("");

  for (int i = 0; i < NOMBRE_DE_GESTION; i++) {
    builtString += String((int)VALEUR_GESTION[i]);

    if (i < NOMBRE_DE_GESTION - 1) {
      builtString += String("|");
    }
  }
  
  Serial.println(builtString);
}

//Fonction qui renvoie vrai si un bouton a été utilisé il y a moins de 30 s
bool VerificationPlusActif(int TEMPS_EN_SECONDE){
  bool res = false;
  if((millis() - DERNIER_UTILISATION) < (TEMPS_EN_SECONDE*1000)){
    res = true;
  }
  return res;
}
